#define KSDL2	1

#define bls_MAXWINDOWS	16
#define bls_KEYBUFSIZ		1024

#if (defined(KSDL2))
	typedef SDL_Window *WID_t;
#elif (defined(KCONSONLY))
	typedef void *WID_t;	// dummy
#endif

typedef struct bls_Window_ {
	char title[64];
	uint32_t xsiz, ysiz, *buf, table_i, keybuf[bls_KEYBUFSIZ], kbw, kbr;
	bls_clock_t lastFlush;
	signed char phase, mode, autoClose, reqClose;
	WID_t hWnd;
	#if (defined(KSDL2))
		SDL_Renderer *rndr;
		SDL_Texture *txtr;
	#endif
} bls_Window;

STATIC void bls_initWin0(bls_Window *w, int xsiz, int ysiz, const char *title, int autoClose);
STATIC void bls_putKeybuf(bls_Window *w, int c);

// level0
STATIC void bls_init();
STATIC void bls_quit();
STATIC void bls_wait0(int msec);
STATIC void bls_openWin0(bls_Window *w);
STATIC void bls_closeWin0(bls_Window *w);
STATIC void bls_flushAll0(bls_Window *w);
STATIC void *bls_malloc(int siz);
STATIC void bls_free(int siz, void *p);
STATIC void bls_exit0(int c);
STATIC bls_clock_t bls_clock();
STATIC void bls_err(const char *s);
extern bls_Window *bls_table_w[bls_MAXWINDOWS + 1];
extern WID_t bls_table_h[bls_MAXWINDOWS];

#define bls_MODE_SET		0
#define bls_MODE_OR		1
#define bls_MODE_AND		2
#define bls_MODE_XOR		3

#define bls_KEY_ENTER		10
#define bls_KEY_ESC		27
#define bls_KEY_BACKSPACE	8
#define bls_KEY_TAB		9
#define bls_KEY_PAGEUP		0x1020
#define bls_KEY_PAGEDWN		0x1021
#define	bls_KEY_END		0x1022
#define	bls_KEY_HOME		0x1023
#define bls_KEY_LEFT		0x1024
#define bls_KEY_RIGHT		0x1025
#define bls_KEY_UP		0x1026
#define bls_KEY_DOWN		0x1027
#define bls_KEY_INS		0x1028
#define bls_KEY_DEL		0x1029

#define bls_KEY_LOCKS		0x00f00000

// level1
inline static int bls_xrgb(int r, int g, int b) { return 1 << 24 | r << 16 | g << 8 | b; }
inline static void bls_setPix0(bls_Window *w, int x, int y, int c) { w->buf[y * w->xsiz + x] = c; }
inline static void bls_setMode(bls_Window *w, int m) { w->mode = m; }
STATIC void bls_wait(int msec);

#if 0

// level1
STATIC void bla_end();
STATIC void bla_leapFlushAll(bla_Window *w, unsigned int t);
STATIC int bla_inkey(bla_Window *w);
STATIC int bla_inkey0(bla_Window *w);	// peek邾.
inline static int bla_getPix(bla_Window *w, int x, int y) { return w->buf[y * w->xsiz + x]; }
STATIC void bla_setPixEx(bla_Window *w, int x, int y, int c);
STATIC void bla_fillRect(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_fillRectEx(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_drawRect(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_drawRectEx(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_drawStr(bla_Window *w, int x, int y, int c, int b, const char *s);
STATIC void bla_drawStrEx(bla_Window *w, int x, int y, int c, int b, const char *s);
STATIC void bla_drawLine(bla_Window *w, int x0, int y0, int x1, int y1, int c);
STATIC void bla_drawLineEx(bla_Window *w, int x0, int y0, int x1, int y1, int c);
STATIC void bla_fillOval(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_fillOvalEx(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_drawOvalEx(bla_Window *w, int sx, int sy, int x0, int y0, int c);
STATIC void bla_fillEx(bla_Window *w, int x, int y, int c);
STATIC void bla_waitEx(int msec);

#endif
